const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Estrutura_projetoDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const estrutura_projeto = await db.estrutura_projeto.create(
      {
        id: data.id || undefined,

        etapa: data.etapa || null,
        atividade: data.atividade || null,
        descricao: data.descricao || null,
        prazo_estimado_dias: data.prazo_estimado_dias || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await estrutura_projeto.setObra(data.obra || null, {
      transaction,
    });

    await estrutura_projeto.setClientes(data.clientes || null, {
      transaction,
    });

    return estrutura_projeto;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const estrutura_projetoData = data.map((item, index) => ({
      id: item.id || undefined,

      etapa: item.etapa || null,
      atividade: item.atividade || null,
      descricao: item.descricao || null,
      prazo_estimado_dias: item.prazo_estimado_dias || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const estrutura_projeto = await db.estrutura_projeto.bulkCreate(
      estrutura_projetoData,
      { transaction },
    );

    // For each item created, replace relation files

    return estrutura_projeto;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const estrutura_projeto = await db.estrutura_projeto.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.etapa !== undefined) updatePayload.etapa = data.etapa;

    if (data.atividade !== undefined) updatePayload.atividade = data.atividade;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    if (data.prazo_estimado_dias !== undefined)
      updatePayload.prazo_estimado_dias = data.prazo_estimado_dias;

    updatePayload.updatedById = currentUser.id;

    await estrutura_projeto.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await estrutura_projeto.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await estrutura_projeto.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return estrutura_projeto;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const estrutura_projeto = await db.estrutura_projeto.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of estrutura_projeto) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of estrutura_projeto) {
        await record.destroy({ transaction });
      }
    });

    return estrutura_projeto;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const estrutura_projeto = await db.estrutura_projeto.findByPk(id, options);

    await estrutura_projeto.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await estrutura_projeto.destroy({
      transaction,
    });

    return estrutura_projeto;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const estrutura_projeto = await db.estrutura_projeto.findOne(
      { where },
      { transaction },
    );

    if (!estrutura_projeto) {
      return estrutura_projeto;
    }

    const output = estrutura_projeto.get({ plain: true });

    output.historico_alteracoes_projeto_estrutura =
      await estrutura_projeto.getHistorico_alteracoes_projeto_estrutura({
        transaction,
      });

    output.maquinas_atividade_estrutura =
      await estrutura_projeto.getMaquinas_atividade_estrutura({
        transaction,
      });

    output.materiais_atividade_estrutura =
      await estrutura_projeto.getMateriais_atividade_estrutura({
        transaction,
      });

    output.pessoas_atividade_estrutura =
      await estrutura_projeto.getPessoas_atividade_estrutura({
        transaction,
      });

    output.obra = await estrutura_projeto.getObra({
      transaction,
    });

    output.clientes = await estrutura_projeto.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.etapa) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('estrutura_projeto', 'etapa', filter.etapa),
        };
      }

      if (filter.atividade) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'estrutura_projeto',
            'atividade',
            filter.atividade,
          ),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'estrutura_projeto',
            'descricao',
            filter.descricao,
          ),
        };
      }

      if (filter.prazo_estimado_diasRange) {
        const [start, end] = filter.prazo_estimado_diasRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            prazo_estimado_dias: {
              ...where.prazo_estimado_dias,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            prazo_estimado_dias: {
              ...where.prazo_estimado_dias,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.estrutura_projeto.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('estrutura_projeto', 'etapa', query),
        ],
      };
    }

    const records = await db.estrutura_projeto.findAll({
      attributes: ['id', 'etapa'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['etapa', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.etapa,
    }));
  }
};
